from nrfhex import *
from shutil import copyfile
import binascii
import sys
import os
import time

def calculate_crc32_from_file(filename):
        buf = open(filename, 'rb').read()
        buf = (binascii.crc32(buf) & 0xFFFFFFFF)
        return "%08X" % buf

if __name__ == '__main__':
    copyfile(sys.argv[1], "dfu_image.hex")
    dfu_image = nRFHex("dfu_image.hex")
    crc_addr = hex(dfu_image.size() + 0x25000) #image size + harcoded bank 1 address
    dfu_image._removeuicr() # Removing UICR data included in hex. It shall not be included in a DFU image. 
    dfu_image.tobinfile("dfu_image.bin")
    crc32 =  calculate_crc32_from_file("dfu_image.bin")

    print("\n\rUploads binary image to address 0x25000 with Jlink commander and writes the CRC-32 value (0x{}) to address {}.".format(crc32, crc_addr))
    print("Application will activate the new image if both CRC is valid and the application has a newer version number.\n\r")

    sys.stdout.flush()

    # Upload image to Bank 1 and write the CRC-32 value
    print "\n\rUploading image with jlink commander\n\r"
    sys.stdout.flush()
    os.system("jlink.exe -device nrf52810_xxaa -if swd -speed 4000 -autoconnect 1 -CommanderScript jlinkcommander.jlink")
    print "Writing CRC"
    sys.stdout.flush()
    time.sleep(1)
    os.system("nrfjprog --memwr {} --val 0x{}".format(crc_addr, crc32))
    os.system("nrfjprog --reset")




